﻿import numpy as np
from numpy.random import *
import copy


class Neuron():
    def __init__(self, sizex): # コンストラクタ 
        self.sizex = sizex # 入力サイズ
        self.w = 0.01 * np.random.rand(sizex+1) #+1 とするのはバイアスを表現するため
        self.y = np.ndarray([]) # このニューロンの出力値
        self.net = 0# このニューロンのnet値
        self.label = '' # ラベル
        
            
    def getOutput(self, x):
        X = copy.deepcopy(x) #  Xは xとバイアス値1.を含む
        X.append(1) # バイアス成分を加える
        self.net = np.ndarray([])
        np.dot(self.w, X, self.net) # net=self.wとXとの内積
        self.y = self.net #1/(1+np.exp(-self.net)) # yを計算
        print("Neuron.getOutput() y=%s" %(self.y))
        return self.y
    
    def learning(self, templeteX, labelY):
        self.w = copy.deepcopy(templeteX)
        normW = np.linalg.norm(templeteX, 2)
        self.w.append(-0.5 * normW*normW) #bias element
        self.label = copy.deepcopy(labelY)
        print("Neuron.learning() self.w=%s, label=%s" %(self.w, self.label))
    

    def display(self):
        print("Neuron.sizex=%s " %(self.sizex))

class NNPerceptron:
    def __init__(self, inputsize):
        self.inputsize = inputsize
        self.units = []
        
    def learning(self, x, y):
        ne = Neuron(self.inputsize)
        ne.learning(x,y)
        self.units.append(ne)
        
    def Reasoning(self, x):
        maxOutput = -1
        for i in range(len(self.units)):
            eachUnit = self.units[i]
            out = eachUnit.getOutput(x)
            if maxOutput < out:
                maxOutput = out
                winnerUnit = eachUnit
        #print("NNPerceptron.Reasoning() %s" %(self.outputs))
        return winnerUnit.label
        
            
if __name__ == "__main__":
    pc = NNPerceptron(2)
    X=[1,2]
    y='red'
    pc.learning(X, y)
    X2=[3,4]
    y2='Yellow'
    pc.learning(X2,y2)
    X3=[1,3]
    print("winner label=%s-->%s" %(X3, pc.Reasoning(X3)))
    
